import os
import re

class xenmouseCheck:
    def __init__(self):
        self.deviceExist = False
        self.deviceName = ""
        self.re = 'xen.*(mouse|pointer)'
        self.probe()

    def isDevicePresent(self):
        return self.deviceExist

    def probe(self):
        i = 0
        while True:
            name = self.readfile("/sys/class/input/input%d/name" % i)
            if not name:
                break
            if re.search(self.re, name, re.IGNORECASE) and self.deviceCheck(i):
                self.deviceName = name
                self.deviceExist = True
                break
            i = i+1

    def readfile(self, name):
        fo = None
        result = ""
        try:
            fo = open(name)
            result = fo.read().strip()
        except IOError:
            pass
        if fo:
            fo.close()
        return result

    def deviceCheck(self, n):
        try:
            dev1 = self.readfile("/sys/class/input/input%d/event%d/dev" % (n, n))
            stat = os.stat("/dev/input/event%d" % n)
            dev2 = "%d:%d" % (os.major(stat.st_rdev), os.minor(stat.st_rdev))
            return dev1 == dev2
        except OSError:
            return False

if __name__ == "__main__":
    x = xenmouseCheck()
    if x.isDevicePresent():
        print "Device: %s" % x.deviceName
    else:
        print "No device found"
    
